module nanorv32_regfile_core (/*AUTOARG*/
   porta, portb,

   // Inputs
  sel_porta,sel_portb,sel_rd,sel_rd2,rd,write_rd,rd2,write_rd2,clk,rst_n,allow_hidden_use_of_x0           
 
   );

   parameter NUM_REGS=32;
`include "nanorv32_parameters.v"

  // Selection
   input [NANORV32_DATA_MSB:0]  sel_porta;
   input [NANORV32_DATA_MSB:0]  sel_portb;
   input [NANORV32_DATA_MSB:0]  sel_rd;
   input [NANORV32_DATA_MSB:0]  sel_rd2;
   
   // Data ports
   output [NANORV32_DATA_MSB:0]     porta;
   output [NANORV32_DATA_MSB:0]     portb;
   input [NANORV32_DATA_MSB:0]      rd;
   input                            write_rd;
   input [NANORV32_DATA_MSB:0]      rd2;
   input                            write_rd2;
   //input                            hreadyd;
   input                            clk;
   input                            rst_n;
   input                            allow_hidden_use_of_x0;
   /*AUTOINPUT*/

  /*AUTOOUTPUT*/

  /*AUTOREG*/
  // Beginning of automatic regs (for this module's undeclared outputs)
  wire [NANORV32_DATA_MSB:0] porta;
  wire [NANORV32_DATA_MSB:0] portb;

  // End of automatics
  genvar i;
  /*AUTOWIRE*/




  reg [NANORV32_DATA_MSB:0] regfile [NUM_REGS-1:0];
   //assign regfile2 = regfile[0];
  
   assign porta = (sel_porta[0] !=  1) || allow_hidden_use_of_x0 ? 
                                         ({32{sel_porta[0]}}&regfile[0])|
                                         ({32{sel_porta[1]}}&regfile[1])|
                                         ({32{sel_porta[2]}}&regfile[2])|
                                         ({32{sel_porta[3]}}&regfile[3])|
                                         ({32{sel_porta[4]}}&regfile[4])|
                                         ({32{sel_porta[5]}}&regfile[5])|
                                         ({32{sel_porta[6]}}&regfile[6])|
                                         ({32{sel_porta[7]}}&regfile[7])|
                                         ({32{sel_porta[8]}}&regfile[8])|
                                         ({32{sel_porta[9]}}&regfile[9])|
                                         ({32{sel_porta[10]}}&regfile[10])|
                                         ({32{sel_porta[11]}}&regfile[11])|
                                         ({32{sel_porta[12]}}&regfile[12])|
                                         ({32{sel_porta[13]}}&regfile[13])|
                                         ({32{sel_porta[14]}}&regfile[14])|
                                         ({32{sel_porta[15]}}&regfile[15])|
                                         ({32{sel_porta[16]}}&regfile[16])|
                                         ({32{sel_porta[17]}}&regfile[17])|
                                         ({32{sel_porta[18]}}&regfile[18])|
                                         ({32{sel_porta[19]}}&regfile[19])|
                                         ({32{sel_porta[20]}}&regfile[20])|
                                         ({32{sel_porta[21]}}&regfile[21])|
                                         ({32{sel_porta[22]}}&regfile[22])|
                                         ({32{sel_porta[23]}}&regfile[23])|
                                         ({32{sel_porta[24]}}&regfile[24])|
                                         ({32{sel_porta[25]}}&regfile[25])|
                                         ({32{sel_porta[26]}}&regfile[26])|
                                         ({32{sel_porta[27]}}&regfile[27])|
                                         ({32{sel_porta[28]}}&regfile[28])|
                                         ({32{sel_porta[29]}}&regfile[29])|
                                         ({32{sel_porta[30]}}&regfile[30])|
                                         ({32{sel_porta[31]}}&regfile[31]) : 0;

   assign portb = (sel_portb[0] != 1) || allow_hidden_use_of_x0 ?  
                                         ({32{sel_porta[0]}}&regfile[0])|
                                         ({32{sel_portb[1]}}&regfile[1])|
                                         ({32{sel_portb[2]}}&regfile[2])|
                                         ({32{sel_portb[3]}}&regfile[3])|
                                         ({32{sel_portb[4]}}&regfile[4])|
                                         ({32{sel_portb[5]}}&regfile[5])|
                                         ({32{sel_portb[6]}}&regfile[6])|
                                         ({32{sel_portb[7]}}&regfile[7])|
                                         ({32{sel_portb[8]}}&regfile[8])|
                                         ({32{sel_portb[9]}}&regfile[9])|
                                         ({32{sel_portb[10]}}&regfile[10])|
                                         ({32{sel_portb[11]}}&regfile[11])|
                                         ({32{sel_portb[12]}}&regfile[12])|
                                         ({32{sel_portb[13]}}&regfile[13])|
                                         ({32{sel_portb[14]}}&regfile[14])|
                                         ({32{sel_portb[15]}}&regfile[15])|
                                         ({32{sel_portb[16]}}&regfile[16])|
                                         ({32{sel_portb[17]}}&regfile[17])|
                                         ({32{sel_portb[18]}}&regfile[18])|
                                         ({32{sel_portb[19]}}&regfile[19])|
                                         ({32{sel_portb[20]}}&regfile[20])|
                                         ({32{sel_portb[21]}}&regfile[21])|
                                         ({32{sel_portb[22]}}&regfile[22])|
                                         ({32{sel_portb[23]}}&regfile[23])|
                                         ({32{sel_portb[24]}}&regfile[24])|
                                         ({32{sel_portb[25]}}&regfile[25])|
                                         ({32{sel_portb[26]}}&regfile[26])|
                                         ({32{sel_portb[27]}}&regfile[27])|
                                         ({32{sel_portb[28]}}&regfile[28])|
                                         ({32{sel_portb[29]}}&regfile[29])|
                                         ({32{sel_portb[30]}}&regfile[30])|
                                         ({32{sel_portb[31]}}&regfile[31]) : 0 ;
 

generate
   for (i = 0; i < 32 ; i = i + 1) begin : loop0
      always @(posedge clk or negedge rst_n) begin
   if (~rst_n) begin
     regfile[i] <= 32'h0;
   end
   else begin
      //if(((sel_rd != 0) || allow_hidden_use_of_x0) && (sel_rd[i] == 1) & write_rd) begin
      if( (sel_rd[i]&write_rd&sel_rd!=0) & (sel_rd[0]!=1 | allow_hidden_use_of_x0) ) begin
        regfile[i] <= rd;
     end
            //else if (((sel_rd2 != 0) || allow_hidden_use_of_x0) && (sel_rd2[i] == 1) && write_rd2) begin
      else if( (sel_rd2[i]&write_rd2&sel_rd2!=0) & (sel_rd2[0]!=1 | allow_hidden_use_of_x0)  ) begin
         regfile[i] <= rd2;  
     end
     
   end
      end
   end
endgenerate
/*
always @(posedge clk or negedge rst_n) begin
   if(~rst_n) begin
      regfile[0] <= 32'h0;
   end
   else begin
     if(allow_hidden_use_of_x0&(sel_rd==0)&write_rd) begin
              regfile[0] <= rd;  
     end
     else if(allow_hidden_use_of_x0&(sel_rd2==0)&write_rd2) begin
            regfile[0] <= rd2;  
     end
   end // else: !if(~rst_n)
end */


wire  [31:0] x0 ;
wire  [31:0] x1 ;
wire  [31:0] x2 ;
wire  [31:0] x3 ;
wire  [31:0] x4 ;
wire  [31:0] x5 ;
wire  [31:0] x6 ;
wire  [31:0] x7 ;
wire  [31:0] x8 ;
wire  [31:0] x9 ;
wire  [31:0] x10;
wire  [31:0] x11;
wire  [31:0] x12;
wire  [31:0] x13;
wire  [31:0] x14;
wire  [31:0] x15;
wire  [31:0] x16;
wire  [31:0] x17;
wire  [31:0] x18;
wire  [31:0] x19;
wire  [31:0] x20;
wire  [31:0] x21;
wire  [31:0] x22;
wire  [31:0] x23;
wire  [31:0] x24;
wire  [31:0] x25;
wire  [31:0] x26;
wire  [31:0] x27;
wire  [31:0] x28;
wire  [31:0] x29;
wire  [31:0] x30;
wire  [31:0] x31;


   wire [31:0] ra ;
   wire [31:0] s0 ;
   wire [31:0] fp ;
   wire [31:0] s1 ;
   wire [31:0] s2 ;
   wire [31:0] s3 ;
   wire [31:0] s4 ;
   wire [31:0] s5 ;
   wire [31:0] s6 ;
   wire [31:0] s7;
   wire [31:0] s8;
   wire [31:0] s9;
   wire [31:0] s10;
   wire [31:0] s11;
   wire [31:0] sp;
   wire [31:0] v0;
   wire [31:0] v1;
   wire [31:0] a0;
   wire [31:0] a1;
   wire [31:0] a2;
   wire [31:0] a3;
   wire [31:0] a4;
   wire [31:0] a5;
   wire [31:0] a6;
   wire [31:0] a7;
   wire [31:0] t0;
   wire [31:0] t1;
   wire [31:0] t2;
   wire [31:0] t3;
   wire [31:0] t4;
   wire [31:0] t5;
   wire [31:0] t6;
   wire [31:0] tp;
   wire [31:0] gp;







assign     x0 =   regfile[0];
assign     x1 =   regfile[1];
assign     x2 =   regfile[2];
assign     x3 =   regfile[3];
assign     x4 =   regfile[4];
assign     x5 =   regfile[5];
assign     x6 =   regfile[6];
assign     x7 =   regfile[7];
assign     x8 =   regfile[8];
assign     x9 =   regfile[9];
assign     x10 =  regfile[10];
assign     x11 =  regfile[11];
assign     x12 =  regfile[12];
assign     x13 =  regfile[13];
assign     x14 =  regfile[14];
assign     x15 =  regfile[15];
assign     x16 =  regfile[16];
assign     x17 =  regfile[17];
assign     x18 =  regfile[18];
assign     x19 =  regfile[19];
assign     x20 =  regfile[20];
assign     x21 =  regfile[21];
assign     x22 =  regfile[22];
assign     x23 =  regfile[23];
assign     x24 =  regfile[24];
assign     x25 =  regfile[25];
assign     x26 =  regfile[26];
assign     x27 =  regfile[27];
assign     x28 =  regfile[28];
assign     x29 =  regfile[29];
assign     x30 =  regfile[30];
assign     x31 =  regfile[31];


   assign     ra =  regfile[1];
   assign     sp =  regfile[2];
   assign     gp =  regfile[3];
   assign     tp =  regfile[4];
   assign     t0 =  regfile[5];
   assign     t1 =  regfile[6];
   assign     t2 =  regfile[7];
   assign     s0 =  regfile[8];
   assign     fp =  regfile[8];
   assign     s1 =  regfile[9];
   assign     a0 =  regfile[10];
   assign     a1 =  regfile[11];
   assign     a2 =  regfile[12];
   assign     a3 =  regfile[13];
   assign     a4 =  regfile[14];
   assign     a5 =  regfile[15];
   assign     a6 =  regfile[16];
   assign     a7 =  regfile[17];
   assign     s2 =  regfile[18];
   assign     s3 =  regfile[19];
   assign     s4 =  regfile[20];
   assign     s5 =  regfile[21];
   assign     s6 =  regfile[22];
   assign     s7 =  regfile[23];
   assign     s8 =  regfile[24];
   assign     s9 =  regfile[25];
   assign     s10 =   regfile[26];
   assign     s11=  regfile[27];
   assign     t3 =  regfile[28];
   assign     t4 =  regfile[29];
   assign     t5 =  regfile[30];
   assign     t6 =  regfile[31];

   integer     jj;
   /* verilator lint_off STMTDLY */
   initial begin
      #1; // spyglass disable CheckDelayTimescale-ML
      for(jj=0;jj<32;jj=jj+1) begin
         regfile[jj] = 32'b0;
      end
   end
endmodule // nanorv32_regfile_core
